var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function getFeed() {
	var sString=Property.getNode('/system/version/distroVersion').getValue();
	if (sString.indexOf('devel')>=0)
		return 0;
	if (sString.indexOf('test')>=0)
		return 1;
	if (sString.indexOf('beta')>=0)
		return 2;
	if (sString.indexOf('alpha')>=0)
		return 2;
	
	return 3;
}


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

function fetchDataForManufacture(supplierID) {
    var h = new HTTP( { 'debug' : 0 }, {});
    lInfo.logln("http://illuminant-wizard.aizo.net/fetchIlluminant.php?id=" + supplierID + "&feed=" + getFeed());
    var code = h.get("http://illuminant-wizard.aizo.net/fetchIlluminant.php?id=" + supplierID + "&feed=" + getFeed(), 'fetchIlluminant.php?feed=' + getFeed());
    if (code.status.valueOf() === 200) {
    	var oAnswer=JSON.parse(code.body);
    	
    }	
}

function prepareSubscription (id) {
	if (Property.getProperty('subscriptions/' + id)==null) {
		var oSubscripion=new Subscription('led-wizard.data-segmented','javascript',
				{'filename1':'/usr/share/dss/data/scripts/http.js',
			     'filename2':'/usr/share/dss/add-ons/led-wizard/fetchSegmentedData.js','script_id':'led-wizard.manufacture-' + id});
		oSubscripion.subscribe();
		Property.setProperty('subscriptions/' + id,true);
	}
}

function fetchStaticData() {
    var db_data;
    var db_update;
    
    try {
        var h = new HTTP( { 'debug' : 0 }, {});
        lInfo.logln("http://illuminant-wizard.aizo.net/staticDB.php?feed=" + getFeed());
        var code = h.get("http://illuminant-wizard.aizo.net/staticDB.php?feed=" + getFeed(), 'staticDB.php?feed=' + getFeed());
        if (code.status.valueOf() === 200) {
            //lInfo.logln('OK [' + code.status + ']' + code.body);           
            var oAnswer=JSON.parse(code.body);
            var fFound=false;
            for (var iIndex=0;iIndex<oAnswer.manufacture.length;iIndex++) {
            	if (oAnswer.manufacture[iIndex].id==-1)
            		fFound=true;
            }
            if (!fFound)
            	oAnswer.manufacture.push({id:-1,name:'Standard',url:'www.aizo.com'});
            oAnswer.mountingForm.push({id:-1,name:'-'});
            oAnswer.socket.push({id:-1,name:'-'});
            oAnswer.abilityDetail.push({id:"-1",name:"-"});
            
            storeSubParameter("db/manufacture",JSON.stringify(oAnswer.manufacture));
            storeSubParameter("db/mountingForm",JSON.stringify(oAnswer.mountingForm));
            storeSubParameter("db/socket",JSON.stringify(oAnswer.socket));
            storeSubParameter("db/abilityDetail",JSON.stringify(oAnswer.abilityDetail));
            Property.store();
            for(var iIndex=0;iIndex<oAnswer.manufacture.length;iIndex++)
            	prepareSubscription(oAnswer.manufacture[iIndex].id);
            new Event('led-wizard.data-segmented',{}).raise();
        } else {
            lWarn.logln(sString + ': FAILED! Server replied: "' + code.status + '"');
            lInfo.logln(code.body);
        }
    } catch (e) {
        lWarn.logln("Error during resyncing cache");
        for (var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
    }

	var iSavedDate=-1;
	try {
		if (Property.getNode('dbrefresh')!=null)
			if (Property.getNode('dbrefresh').getValue()!=null)
				iSavedDate=Property.getNode('dbrefresh').getValue();
		if (iSavedDate<0) {
			lWarn.logln('must using offline cache');
			
		} else
			lWarn.logln('using online cache');
	} catch (e) {
	    lWarn.logln("Error during resyncing cache");
	    for (var i in e) {
	        lWarn.logln(i + ': ' + e[i]);
	    }
	}
}

if (raisedEvent.name=='led-wizard.data-static') {
	fetchStaticData();
} else {
	Property.setProperty("manufacture", "?");
	var pProperty=Property.getNode('manufacture').getPath();
	pProperty=pProperty.substring(32);
	pProperty=pProperty.substring(0,pProperty.indexOf('/'))
	fetchDataForManufacture(pProperty);
	
}