var progDSID = "";
var progKurve = 0;
var progPos = 0;
var colcnt=22;
var offlinemode=0;

function array_sort_name(amul) {
   var i = 0;
   var j = 0;
   var tmp = null;
   for (i = 0; i < (amul.length - 1); i++) {
      for (j = i + 1; j < amul.length; j++) {
         if (amul[j].name < amul[i].name) {
            tmp = amul[j];
            amul[j] = amul[i];
            amul[i] = tmp;
         }
      }
   }
}

function $(id){ return document.getElementById(id); }
function html(id, html){ $(id).innerHTML = html; }
function XHR(u,f,v){var x=this.ActiveXObject;x=new(x?x:XMLHttpRequest)('Microsoft.XMLHTTP');x.open('GET',u,1);x.onreadystatechange=function(){x.readyState>3?x.status==200?f(eval("("+x.responseText+")"),v):0:0};x.send(null)}

var W = 400,
    H = 300,
    r,
    X = [],
    Y = [],
    path,
    sub,
    blankets,
    buttons,
    changing=0,
    values = [],
    len = 17;

 for (var i = len; i--;) {
     values.push(50);
 }

 function ruecktranslate(y) {
     return Math.round(((H - 10 - y) * 255) / (H - 20));
 }

 var update = function (i, d) {
     (d > H - 10) && (d = H - 10);
     (d < 10) && (d = 10);
     Y[i] = d;
     drawPath();
     buttons.items[i].attr({cy: d});
     blankets.items[i].attr({cy: d});
     r.safari();
     html('v'+(i+1),ruecktranslate(d));
 };

 function translate(x, y) {
     return [
         50 + (W - 60) / (values.length - 1) * x,
         (H - 10) - (((H - 20) / 255) * y)
     ];
 }
 
 function drawPath() {
     var p = [];
     for (var j = 1, jj = X.length; j < jj; j++) {
         p.push(X[j], Y[j]);
     }
     p = ["M", X[0], Y[0], "L"].concat(p);
     var subaddon = "L" + (W - 10) + "," + (H - 10) + ",50," + (H - 10) + "z";
     path.attr({path: p});
     sub.attr({path: p + subaddon});
 }

 function graphInit() {
    r = Raphael("holder", W, H);
    var p = [["M"].concat(translate(0, values[0]))],
        color = "hsb(30, 1, 1)",
        colorsub = "hsb(40, 1, 1)",
        w = (W - 60) / values.length,
        isDrag = -1,
        start = null,
        unhighlight = function () {};
    blankets = r.set();
    buttons = r.set();
    sub = r.path().attr({stroke: "none", fill: [180, colorsub, colorsub].join("-"), opacity: 0});
    path = r.path().attr({stroke: color, "stroke-width": 2});
    var ii;
    for (i = 0, ii = values.length - 1; i < ii; i++) {
        var xy = translate(i, values[i]),
            xy1 = translate(i + 1, values[i + 1]),
            f;
        X[i] = xy[0];
        Y[i] = xy[1];
        (f = function (i, xy) {
            buttons.push(r.circle(xy[0], xy[1], 3).attr({fill: color, stroke: "none"}));
            blankets.push(r.circle(xy[0], xy[1], w / 2).attr({stroke: "none", fill: "#fff", opacity: 0}).mouseover(function () {
                if (!changing) return;

                if (isDrag + 1) {
                    unhighlight = function () {};
                } else {
                    buttons.items[i].animate({r: 10}, 200);
                }
            }).mouseout(function () {
                if (!changing) return;

                if (isDrag + 1) {
                    unhighlight = function () {
                        buttons.items[i].animate({r: 6}, 200);
                    };
                } else {
                    buttons.items[i].animate({r: 6}, 200);
                }
            }).drag(function (dx, dy) {
                if (!changing) return;

                var start = this.start;
                start && update(start.i, start.p + dy);
            }, function (x, y) {
                this.start = {i: i, m: y, p: Y[i]};
            }));
            blankets.items[blankets.items.length - 1].node.style.cursor = "default";
        })(i, xy);
        if (i == ii - 1) {
            f(i + 1, xy1);
        }
    }
    xy = translate(ii, values[ii]);
    X.push(xy[0]);
    Y.push(xy[1]);
    
    drawPath();
};

function doExpert() {
   if ($('edit').checked) {
      for (var i = 0; i< (values.length); i++) {
         buttons.items[i].animate({r: 6}, 200);
         blankets.items[i].node.style.cursor = "move";
      }
      changing = 1;
   } else {
      for (var i = 0; i< (values.length); i++) {
         buttons.items[i].animate({r: 3}, 200);
         blankets.items[i].node.style.cursor = "default";
      }
      changing = 0;
   }
}

// choose curve
function cc() {
   var Ausgabe="";
   if (!offlinemode) {
//      html("KurvenPic", "<img src=\""+db_data[$('selkurve').value][21]+"\">\n");
   }

   for (var i=0; i<23; i++) {
      Ausgabe+=db_data[$('selkurve').value][i]+",";
   }
//   html("KurvenPicNew", Ausgabe);
   for (var i=1; i<18; i++) {
      update(i-1,translate(i-1,db_data[$('selkurve').value][i])[1]);
   }
   drawPath();

}

// choose zone
function cz() {
   var Ausgabe="";
   z = $('selzone').value;

   Ausgabe="";
   Ausgabe=Ausgabe+"<form name=\"f3\"><select name=\"seldevice\" id=\"seldevice\">\n";

   Ausgabe=Ausgabe+"<option value=\"-2\" selected>Ger&auml;teauswahl</option>";
   Ausgabe=Ausgabe+"<option value=\"-1\">-----------------------</option>";

   if ( (z >0) && (zones[z].devices) ) {
      array_sort_name(zones[z].devices); // Devices sortieren
      for (d = 0; d < zones[z].devices.length; d++) {
         if (zones[z].devices[d].dSID.substr(16,3) == "ffc")
            continue; // simulierte Gerte nicht ausgeben
         if (zones[z].devices[d].present == false)
            continue; // nicht vorhandene Gerte nicht ausgeben

         Ausgabe=Ausgabe+"<option value=\""+d+"\">"+zones[z].devices[d].name+" ("+zones[z].devices[d].dSID.substr(16,8)+")</option>\n";
      }

      Ausgabe=Ausgabe+"</select>&nbsp;&nbsp;&nbsp;<input type=\"button\" name=\"go\" value=\"Go\" onclick=\"goProg()\">\n";
   } else
      Ausgabe=Ausgabe+"</select>\n";
   Ausgabe=Ausgabe+"</form>\n";

   html("Device", Ausgabe);
}

function SaveDB(response, state) {
   var s="";

   if (state == -20) {
      // prfe, ob db vorhanden
      html("DBstate", "Prfe Offlinedatenbank");
      XHR("/json/property/getString?path=/scripts/dimmer/db/cnt", SaveDB, -19);
   } else
   if (state == -19) {
      if ( (response.ok == false) || (response.result.value <= 0) ) {
         // db muss neu gespeichert werden
         SaveDB(0,-10);
      } else {
         // prfe db version
         XHR("/json/property/getString?path=/scripts/dimmer/db/update", SaveDB, -18);
      }
   } else
   if (state == -18) {
      if ( (response.ok == false) || (response.result.value != db_update) ) {
         // db muss neu gespeichert werden
         SaveDB(0,-10);
      } else {
         // db aktuell, lese Speicherdatum
         XHR("/json/property/getString?path=/scripts/dimmer/db/ts", SaveDB, -17);
      }
   } else
   if (state == -17) {
      if ( (response.ok == false) || (response.result.value <= 0) ) {
         // db muss neu gespeichert werden
         SaveDB(0,-10);
      } else {
         var ts=new Date(parseInt(response.result.value));
         var tsu=new Date(parseInt(db_update*1000));
         html("DBstate", "Offlinedatenbank bereits aktuell, zuletzt aktualisert am " + ts.getDate()+"."+(ts.getMonth()+1)+"."+ts.getFullYear() + ", Datenbankstand vom " + tsu.getDate()+"."+(tsu.getMonth()+1)+"."+tsu.getFullYear());
      }
   } else
   if (state == -10) {
      // delete DB
      html("DBstate", "Lsche Offlinedatenbank");
      XHR("/json/property/remove?path=/scripts/dimmer/db", SaveDB, 0);
   } else
   if (state == -8) {
      // save timestamp
      html("DBstate", "Datenbankaktualisierung wird abgeschlossen");
      XHR("/json/property/setString?path=/scripts/dimmer/db/update&value="+db_update, SaveDB, -7);
   } else
   if (state == -7) {
      // save timestamp
      XHR("/json/property/setFlag?path=/scripts/dimmer/db/update&flag=ARCHIVE&value=true", SaveDB, -6);
   } else
   if (state == -6) {
      // save timestamp
      var ts=new Date();
      XHR("/json/property/setString?path=/scripts/dimmer/db/ts&value="+ts.getTime(), SaveDB, -5);
   } else
   if (state == -5) {
      // save timestamp
      XHR("/json/property/setFlag?path=/scripts/dimmer/db/ts&flag=ARCHIVE&value=true", SaveDB, -4);
   } else
   if (state == -4) {
      // save cnt
      XHR("/json/property/setString?path=/scripts/dimmer/db/cnt&value="+db_cnt, SaveDB, -3);
   } else
   if (state == -3) {
      // save cnt
      XHR("/json/property/setFlag?path=/scripts/dimmer/db/cnt&flag=ARCHIVE&value=true", SaveDB, -2);
   } else
   if (state == -2) {
      // store DB
      XHR("/json/event/raise?name=dimmer&parameter=actions=save", SaveDB, -1);
   } else
   if (state == -1) {
      // fertig
      html("DBstate", "Offlinedatenbank erfolgreich aktualisiert");
   } else
   if (state>= 0) {
      if (state < (db_cnt*2)) {
         html("DBstate", "Speichere in Offlinedatenbank "+state+" / " +(db_cnt*2));
         var entry_no = Math.floor(state / 2);
         var arch = state % 2;

         state++;

         if (arch == 0) {
            var s=db_data[entry_no][0];
            for (var i=1; i<colcnt; i++) {
                s=s+"," + db_data[entry_no][i];
            }
            XHR("/json/property/setString?path=/scripts/dimmer/db/"+entry_no+"&value="+escape(s), SaveDB, state);
         } else {
            XHR("/json/property/setFlag?path=/scripts/dimmer/db/"+entry_no+"&flag=ARCHIVE&value=true", SaveDB, state);
         }
      } else {
         SaveDB(0,-8);
      }
   }
}

/*
function LoadDB(response, state) {
   var s="";

   if (state == -20) {
      // prfe, ob db vorhanden
      html("DBstate", "Prfe Offlinedatenbank");
      XHR("/json/property/getString?path=/scripts/dimmer/db/cnt", LoadDB, -19);
   } else
   if (state == -19) {
      if ( (response.ok == false) || (response.result.value <= 0) ) {
         // Offlinedatenbank nicht vorhanden
         alert("Fehler1");
      } else {
         // db aktuell, lese Speicherdatum
         db_cnt = parseInt(response.result.value);
         XHR("/json/property/getString?path=/scripts/dimmer/db/ts", LoadDB, -18);
      }
   } else
   if (state == -18) {
      if ( (response.ok == false) || (response.result.value <= 0) ) {
         // Offlinedatenbank nicht vorhanden
         alert("Fehler2");
      } else {
         var ts=new Date(parseInt(response.result.value));
         html("Info", "Offlinedatenbank aktualisert am " + ts.getDate()+"."+(ts.getMonth()+1)+"."+ts.getFullYear());
         html("DBstate", "Offlinedatenbank aktualisert am " + ts.getDate()+"."+(ts.getMonth()+1)+"."+ts.getFullYear());
         db_data = new Array();
         XHR("/json/property/getString?path=/scripts/dimmer/db/0", LoadDB, 0);
      }
   } else
   if (state == -1) {
      // fertig
      html("DBstate", "Offlinedatenbank erfolgreich eingelesen");
      doAusgabe();
   } else
   if (state>= 0) {
      if (response.ok == false) {
         // Offlinedatenbank nicht vorhanden
         alert("Fehler3");
      }
      var data = response.result.value;
      db_data[state] = data.split(",");
      state++;

      if (state < (db_cnt)) {
         html("DBstate", "Lade Offlinedatenbank "+state+" / " +(db_cnt-1));
         XHR("/json/property/getString?path=/scripts/dimmer/db/"+state, LoadDB, state);
      } else {
         LoadDB(0,-1);
      }
   }
}
*/

function LoadDB(response, state) {
   var s="";

   if (state == 0) {
      // prfe, ob db vorhanden
      html("DBstate", "Prfe Offlinedatenbank");
      XHR("/json/property/query?query=/scripts/dimmer/db(*)", LoadDB, 1);
   } else
   if (state == 1) {
      if ( (response.ok == false) || (typeof response.result.db == 'undefined') || (response.result.db.length<1) || (typeof response.result.db[0].cnt == 'undefined') || (response.result.db[0].cnt <= 0) ) {
         // Offlinedatenbank nicht vorhanden
         html("DBstate", "Offlinedatenbank konnte nicht gefunden werden. Bitte Internetverbindung am Computer herstellen und Add-On erneut starten.");
      } else {
         // db vorhanden
         db_cnt = parseInt(response.result.db[0].cnt);
         var ts=new Date(parseInt(response.result.db[0].ts));
         var tsu=new Date(parseInt(response.result.db[0].update*1000));
         html("DBstate", "Offlinedatenbank erfolgreich eingelesen, zuletzt aktualisiert am " + ts.getDate()+"."+(ts.getMonth()+1)+"."+ts.getFullYear() + ", Datenbankstand vom " + tsu.getDate()+"."+(tsu.getMonth()+1)+"."+tsu.getFullYear());
         
         db_data = new Array();
         for (var i=0; i<db_cnt; i++) {
            db_data[i] = response.result.db[0][i].split(",");
         }
         doAusgabe();
      }
   }
}

function writePara(dsid, bank, ind, value, func, val) {
   XHR("/json/device/setConfig?dsid=" + dsid + "&value=" + (value & 0xFF) + "&class=" + bank + "&index=" + ind, func, val);
}

function doProg() {
   progPos++;
   html("Info", "Programmiere "+progDSID+" mit Kurve "+progKurve+", Position: "+progPos);
   switch (progPos) {
      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
      case 6:
      case 7:
      case 8:
      case 9:
      case 10:
      case 11:
      case 12:
      case 13:
      case 14:
      case 15:
      case 16:
      case 17:
         writePara(progDSID, 3, 0x2F+progPos, db_data[progKurve][progPos], function(){},0); 
         break;
      case 18:
         writePara(progDSID, 4, 0x28, db_data[progKurve][18], function(){},0); 
         break;
      case 19:
         writePara(progDSID, 4, 0x29, db_data[progKurve][19], function(){},0); 
         break;
      case 20:
         writePara(progDSID, 4, 0x2c, db_data[progKurve][20] & 0xFF, function(){},0); 
         break;
      case 21:
         writePara(progDSID, 4, 0x2d, db_data[progKurve][20] >> 8, function(){},0); 
         break;
      case 22:
      case 23:
      case 24:
         html("Info", "Programmiere "+progDSID+" mit Kurve "+progKurve+", FERTIG!");
         break;
      case 25:
         html("Info", "");
         document.f3.go.disabled=false;
         return;
   }
   window.setTimeout("doProg()", 1000);
}

function goProg() {
   k = $('selkurve').value;
   z = $('selzone').value;
   d = $('seldevice').value;

   if ((z>=0) && (d>=0)) {
      progDSID = zones[z].devices[d].dSID;
      progKurve = k;
      progPos = 0;
      document.f3.go.disabled=true;
      doProg();
   } else {
      html("Info", "");
   }
}

function doAusgabe() {
   var Ausgabe="";

   Ausgabe=Ausgabe+"<form name=\"f1\"><select name=\"selkurve\" id=\"selkurve\" onchange=\"cc()\">\n";

   for (i=0; i<db_cnt; i++) {
      Ausgabe=Ausgabe+"<option value=\""+i+"\"";
      if (i==0)
         Ausgabe=Ausgabe+" selected";
      Ausgabe=Ausgabe+">"+db_data[i][0]+"</option>\n";
   }
   Ausgabe=Ausgabe+"</select></form>\n";

   html("Kurve", Ausgabe);
   cc();

   Ausgabe="";
   Ausgabe=Ausgabe+"<form name=\"f2\"><select name=\"selzone\" id=\"selzone\" onchange=\"cz()\">\n";

   Ausgabe=Ausgabe+"<option value=\"-2\" selected>Zonenauswahl</option>";
   Ausgabe=Ausgabe+"<option value=\"-1\">-----------------------</option>";

   array_sort_name(zones); // Zonen nach Namen sortieren
   for (z = 0; z < zones_cnt; z++) {
      if (zones[z].ZoneID == 0)
         continue; // Broadcast-Zone nicht ausgeben

      if (zones[z].name == "")
         zones[z].name = "Unbenannt";

      Ausgabe=Ausgabe+"<option value=\""+z+"\">"+zones[z].name+"</option>\n";

   }
   Ausgabe=Ausgabe+"</select></form>\n";

   html("Zone", Ausgabe);
   cz();

}
function readZonesAndDevices(r) {
   zones = r.result.zones;
   zones_cnt = r.result.zones.length;
   html("Info", "");

   // !-- DEBUG:
//   db_cnt = 0;

   if (db_cnt == 0) {
      offlinemode=1;
      LoadDB(0,0);
   } else {
      // traverse db entries and replace , to ; or .
      for (var entry_no=0; entry_no<db_cnt; entry_no++) {
         db_data[entry_no][0].replace(/,/, ";");
         for (var i=1; i<colcnt; i++) {
             db_data[entry_no][i].replace(/,/, ".");
         }
      }
      SaveDB(0,-20);
      doAusgabe();
   }
}

function Start() {
   html("Info", "Lade ...");
   // Zonen laden
   XHR("/json/property/query?query=/apartment/zones/*(ZoneID, name)/devices/*(name, dSID, functionID, present, productID, revisionID)", readZonesAndDevices);
   graphInit();
}